/*C****************************************************************************
* $RCSfile: uartnoint_lib.c,v $
*------------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*------------------------------------------------------------------------------
* J			: $Name:  $
* 			: $Revision: 1.1 $
* ̧ٓt/	: $Id: uartnoint_lib.c,v 1.1 2003/07/04 13:17:56 jberthy Exp $
*------------------------------------------------------------------------------
* ړI			: 荞݂ȂœUARTpʋ@\̒
******************************************************************************/

//-----------------------------------------------------------------------------
// gp
// ======
//
// #define XTAL_CPU_8         8000000		//     8  MHz
// #define BAUD_RATE_9600        9600		//  9600  bps
// #define BAUD_RATE_115K2     115200		// 115.2 kbps
//
// InitUART_0(UART_BAUD(BAUD_RATE_115K2,XTAL_CPU_8));	// UART0\ݒ
// InitUART_1(UART_BAUD(BAUD_RATE_9600, XTAL_CPU_8));	// UART1\ݒ
//
// CPrintfUART_0("\r\nBonjour, Maitre\r\n");
//
// DPrintfUART_1(UART_Temp);
//-----------------------------------------------------------------------------

/*_____ ݸٰ ̧ ________________________________________________________*/
#include "config.h"
#include "uartnoint_lib.h"

/*F****************************************************************************
* ֐ : InitUART_0
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART08ޯ ް,èȂ,2~ޯĂɏAްڰĐݒA荞݋֎~
* 	: Uint16 = UART_BAUD()ϸۂgp"baud"
* o	: Ȃ
******************************************************************************/
void InitUART_0 (Uint16 baud)
{
  UCSR0B = 0;							// UART0M֎~

  UBRR0H = (Uchar) (baud>>8);			// UART0ްڰĐݒ
  UBRR0L = (Uchar)  baud;

  UCSR0A = (1<<UDRE0);					// (Ӗ)
  UCSR0C = (1<<USBS0) | (1<<UCSZ01) | (1<<UCSZ00);		// 2~ޯ,8ޯ ްw

  UCSR0B = (1<<RXEN0) | (1<<TXEN0);		// UART0M()
}

/*F****************************************************************************
* ֐ : InitUART_1
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART18ޯ ް,èȂ,2~ޯĂɏAްڰĐݒA荞݋֎~
* 	: Uint16 = UART_BAUD()ϸۂgp"baud"
* o	: Ȃ
******************************************************************************/
void InitUART_1 (Uint16 baud)
{
  UCSR1B = 0;							// UART1M֎~

  UBRR1H = (Uchar) (baud>>8);			// UART1ްڰĐݒ
  UBRR1L = (Uchar) baud;

  UCSR1A = (1<<UDRE1);					// (Ӗ)
  UCSR1C = (1<<USBS1) | (1<<UCSZ11) | (1<<UCSZ10);		// 2~ޯ,8ޯ ްw

  UCSR1B = (1<<RXEN1) | (1<<TXEN1);		// UART1M()
}

/*F****************************************************************************
* ֐ : GetCharUART_0
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART0M޲Ď擾
* 	: Ȃ
* o	: Uchar = UART0MA܂͖M̏ꍇ$00
******************************************************************************/
Uchar GetCharUART_0 (void)
{
  Uchar  temp;

  if ( !(UCSR0A & (1<<RXC0)) ) temp = FALSE;	// MŁAtemp=0
  else temp = UDR0;								// MŁAtemp=Ml
  return temp;									// Ml܂0ƋɕA
}

/*F****************************************************************************
* ֐ : GetCharUART_1
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART1M޲Ď擾
* 	: Ȃ
* o	: Uchar = UART1MA܂͖M̏ꍇ$00
******************************************************************************/
Uchar GetCharUART_1 (void)
{
  Uchar  temp;

  if ( !(UCSR1A & (1<<RXC1)) ) temp = FALSE;	// MŁAtemp=0
  else temp = UDR1;								// MŁAtemp=Ml
  return temp;									// Ml܂0ƋɕA

/*F****************************************************************************
* ֐ : PutCharUART_0
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART0ŕM
* 	: Uchar = UART0őMׂ
* o	: Ȃ
******************************************************************************/
void PutCharUART_0 (Uchar char2send)
{
  while ( !(UCSR0A & (1<<UDRE0)) );		// Mް ڼ޽󂫑ҋ@
  UDR0 = char2send;						// MJn
}

/*F****************************************************************************
* ֐ : PutCharUART_1
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART1ŕM
* 	: Uchar = UART1őMׂ
* o	: Ȃ
******************************************************************************/
void PutCharUART_1 (Uchar char2send)
{
  while ( !(UCSR1A & (1<<UDRE1)) );		// Mް ڼ޽󂫑ҋ@
  UDR1 = char2send;						// MJn
}

/*F****************************************************************************
* ֐ : CPrintfUART_0
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART0ASCIIZ萔񑗐M
* 	: ASCIIZւ߲
* o	: Ȃ
******************************************************************************/
void CPrintfUART_0 (const Uchar *cstring)
{
  while(*cstring) PutCharUART_0 (*cstring++);	// NULO܂UART0M
}

/*F****************************************************************************
* ֐ : CPrintfUART_1
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART1ASCIIZ萔񑗐M
* 	: ASCIIZւ߲
* o	: Ȃ
******************************************************************************/
void CPrintfUART_1 (const Uchar *cstring)
{
  while(*cstring) PutCharUART_1 (*cstring++);	// NULO܂UART1M
}

/*F****************************************************************************
* ֐ : DPrintfUART_0
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART0ASCIIZϐ񑗐M
* 	: ASCIIZւ߲
* o	: Ȃ
******************************************************************************/
void DPrintfUART_0 (Uchar *dstring)
{
  while(*dstring) PutCharUART_0 (*dstring++);	// NULO܂UART0M
}


/*F****************************************************************************
* ֐ : DPrintfUART_1
*------------------------------------------------------------------------------
* 	: J TELLIER
* t	: 13/06/903
* J	: date - name
*------------------------------------------------------------------------------
* ړI	: UART1ASCIIZϐ񑗐M
* 	: ASCIIZւ߲
* o	: Ȃ
******************************************************************************/
void DPrintfUART_1 (Uchar *dstring)
{
  while(*dstring) PutCharUART_1 (*dstring++);	// NULO܂UART1M
}

