/*
**
*******************************************************************************
**
**
**		Copyright (c) 2004/2005 - Atmel Corporation
**		L
**
**  -
**
** ATMEL - 2005
** SĂ̿ĳ ۸т͂ǂȎނ̕ۏ؂Ȃ"󂻂̂"Œ񋟂܂B
** ATMEL͂ǂȖړIɑ΂Ă񋟂fނ̓K۔F܂BATMEL͑SĂ̈
** ٓIȕۏ؁AړIւ̓KALA@܂݁A񋟂ĳɊ֘A
** SĂ̕ۏ؂ƏŔ۔F܂B̿ĳ ۸т̎gp̌ʂł
** ĂAǂȊԐړIApIȑQA܂͂ǂȑQɑ΂ĂAƂɂ
** SATMELɐӔCȂł傤B
*******************************************************************************
**
*/

#ifndef _BOARD_H
#define _BOARD_H

/*_____ ` ________________________________________________________________*/

//---------------------------------------------------------------------------//
//	MCU߰Đ錾																 //
//---------------------------------------------------------------------------//

// ߰A
#define _PUSH1			0x01	// PA0(AD0)
#define _PA1			0x02	// PA1(AD1)
#define _PA2			0x04	// PA2(AD2)
#define _PA3			0x08	// PA3(AD3)
#define _PA4			0x10	// PA4(AD4)
#define _PA5			0x20	// PA5(AD5)
#define _PA6			0x40	// PA6(AD6)
#define _PA7			0x80	// PA7(AD7)

// ߰B
#define _PB0			0x01	// PB0(/SS)
#define _PB1			0x02	// PB1(SCK)
#define _PB2			0x04	// PB2(MOSI)
#define _PB3			0x08	// PB3(MISO)
#define _PB4			0x10	// PB4(OC2A)
#define _PB5			0x20	// PB5(OC1A)
#define _PB6			0x40	// PB6(OC1B)
#define _PB7			0x80	// PB7(OC0A/OC1C)

// ߰C
#define _LIN_SLEEP		0x01	// PC0(A8)
#define _PC1			0x02	// PC1(A9)
#define _PC2			0x04	// PC2(A10)
#define _PC3			0x08	// PC3(A11)
#define _PC4			0x10	// PC4(A12)
#define _PC5			0x20	// PC5(A13)
#define _PC6			0x40	// PC6(A14)
#define _PC7			0x80	// PC7(A15/CLKO)

// ߰D
#define _PD0			0x01	// PD0(SCL/INT0)
#define _PD1			0x02	// PD1(SDA/INT1)
#define _LIN_RXD_A		0x04	// PD2(RXD1/INT2)
#define _LIN_TXD		0x08	// PD3(TXD1/INT3)
#define _LIN_RXD_B		0x10	// PD4(IC1)
#define _PD5			0x20	// PD5(XCK1/TxCAN)
#define _PD6			0x40	// PD6(T1/RxCAN)
#define _GREEN_LED		0x80	// PD7(T0)

// ߰E
#define _PE0			0x01	// PE0(RXD0/PDI)
#define _PE1			0x02	// PE1(TXD0/PDO)
#define _PE2			0x04	// PE2(XCK0/AIN0)
#define _PE3			0x08	// PE3(OC3A/AIN1)
#define _PE4			0x10	// PE4(OC3B/INT4)
#define _PE5			0x20	// PE5(OC3C/INT5)
#define _PE6			0x40	// PE6(T3/INT6)
#define _PE7			0x80	// PE7(IC3/INT7)

// ߰F
#define _PF0			0x01	// PF0(ADC0)
#define _PF1			0x02	// PF1(ADC1)
#define _PF2			0x03	// PF2(ADC2)
#define _PF3			0x04	// PF3(ADC3)
#define _PF4			0x10	// PF4(ADC4(JTAG))
#define _PF5			0x20	// PF5(ADC5(JTAG))
#define _PF6			0x40	// PF6(ADC6(JTAG))
#define _PF7			0x80	// PF7(ADC7(JTAG))

// ߰G
#define _PG0			0x01	// PG0(/WR)
#define _PG1			0x02	// PG1(/RD)
#define _PG2			0x02	// PG2(ALE)
#define _PG3			0x08	// PG3(TOSC2)
#define _PG4			0x10	// PG4(TOSC1)

//---------------------------------------------------------------------------//
//	MCU苖/֎~ϸ														 //
//---------------------------------------------------------------------------//
#define ENABLE_LIN()	(DDRC |=_LIN_SLEEP , PORTC  |=_LIN_SLEEP)
#define DISABLE_LIN()	(DDRC |=_LIN_SLEEP , PORTC &=~_LIN_SLEEP)

//---------------------------------------------------------------------------//
//	MCU߰Č`Ԑݒϸ														 //
//---------------------------------------------------------------------------//

#define CONFIG_PORTA()		(DDRA   = 0x00)
#define CONFIG_PORTB()		(DDRB   = 0x00)
#define CONFIG_PORTC()		(DDRC   = _LIN_SLEEP )
#define CONFIG_PORTD()		(DDRD   = _GREEN_LED   | _LIN_TXD ,  PORTD  = _LIN_TXD | _LIN_RXD_A | _LIN_RXD_B )
#define CONFIG_PORTE()		(DDRE   = DDRE  )
#define CONFIG_PORTF()		(DDRF   = DDRF )
#define CONFIG_PORTG()		(DDRG   = DDRG )

#define CONFIG_IO_PORTS()	( CONFIG_PORTA(),  CONFIG_PORTB(),  CONFIG_PORTC(),  CONFIG_PORTD(), CONFIG_PORTE(), CONFIG_PORTF(),CONFIG_PORTG())

//---------------------------------------------------------------------------//
//	MCUoϸ															 //
//---------------------------------------------------------------------------//
#define SET_GREEN_LED()		(PORTD |= _GREEN_LED )
#define SET_LIN_TXD()		(PORTD |= _LIN_TXD )

#define RESET_GREEN_LED()	(PORTD &= ~_GREEN_LED )
#define RESET_LIN_TXD()		(PORTD &= ~_LIN_TXD )

#define TOGGLE_GREEN_LED()	(PORTD ^= _GREEN_LED )
#define TOGGLE_LIN_TXD()	(PORTD ^= _LIN_TXD )

#define _TEST_PUSH1()		(PINA & _PUSH1 )

#endif  /* _BOARD_H */



