/*
**
****************************************************************************
**
**
**		Copyright (c) 2004/2005 - Atmel Corporation
**		L
**
** 		: AVR LIN呕u
** 		: master_lin.c
** 		: LIN1.3Ŏ呕uޭ
** ړIΏ	: ATMEGA48/88/168AT90CAN128
** ߲	: IAR Embedded Workbench 4.1
**
** : t:	  : :
** 1.0 5.1.2005   E.G.  쐬
**
**  -
**
** ATMEL - 2004/2005
** SĂ̿ĳ ۸т͂ǂȎނ̕ۏ؂Ȃ"󂻂̂"Œ񋟂܂B
** ATMEL͂ǂȖړIɑ΂Ă񋟂fނ̓K۔F܂BATMEL͑SĂ̈
** ٓIȕۏ؁AړIւ̓KALA@܂݁A񋟂ĳɊ֘A
** SĂ̕ۏ؂ƏŔ۔F܂B̿ĳ ۸т̎gp̌ʂł
** ĂAǂȊԐړIApIȑQA܂͂ǂȑQɑ΂ĂAƂɂ
** SATMELɐӔCȂł傤B
****************************************************************************
**
*/

/* `̏ꍇMASTER_LIN_C` */
#define MASTER_LIN_C

#include "lib_mcu/lin_uart/master_lin.h"

t_schedule my_schedule;			// ݂̌v敔
lin_status_t lin_status;		// LIN
st_lin_t msg_lin;				// LINүލ\
st_cmd_lin_t cmd_lin;			// LINߍ\
U8 tab_data[8];					// LINް ޯ̧
static U16 LinTxCtr;			// MJnxv(ޯĎԒP)
U8 Frame_index;					// ڰшʒuwq

#ifdef _SLEEP_TIMOUT_DETECTION
U8 LINSleepFlag;				// LINx~׸
U8 lin_sleep_message_request;	// Lʎ呕uvł̋x~ߗv׸
#endif

#ifdef _COUNTING_ERRORS_ENABLE
U16 countCERR;					// ьv
U16 countRERR;					// ]uُv(呕û)
U16 countBERR;					// ޯĈُv평
U16 countSERR;					// ُv평
U16 countPERR;					// èv
#endif

//-----------------------------------------------------------------------------
// : ASCIIɕϊ֐(\pɗLp!)
// : ϊ邽߂8ޯĐ
// o: ΉASCII޲
// ----------------------------------------------------------------------------
char int2hex(unsigned char integer) {

  if(integer < 10) {							// 10ŁA
	return integer+ASCII_NUM_OFFSET;			// ΉASCIIƋɕA
  }else{										// 10ȏŁA
	return integer+55;							// ΉASCII'A'`ƋɕA
  }
}

//-----------------------------------------------------------------------------
// : LINvn(v(tick)֐p)
//-----------------------------------------------------------------------------
void LIN_TIMER_init (void){

  TIMSK1 |= 1 << TOIE1;							// /1ꊄ荞݋
  TCCR1A = 0x00;								// Ww
  TCCR1B = 0x01;								// OuȂŎn
  TCNT1H = _8MHZ_TCNT1H;						// ޯĎԂɑΉlŏ
  TCNT1L = _8MHZ_TCNT1L;
}

//-----------------------------------------------------------------------------
// : LINʎqDLCϊ
//-----------------------------------------------------------------------------
U8 id_to_dlc (U8 lin_id) {

  U8 lin_dlc = (lin_id & 0x30) >>4;				// ʎqDLCޯĂ̂ݒo
  if (lin_dlc < 2){								// DLC=00܂01ŁA
	lin_dlc = 2;								// 2޲Ďw
  }else if (lin_dlc == 2){						// DLC=10ŁA
	lin_dlc = 4;								// 4޲Ďw
  }else{										// DLC=11ŁA
	lin_dlc = 8;								// 8޲Ďw
  }
  return lin_dlc;								// ޲ĐƋɕA
}

//-----------------------------------------------------------------------------
// : LINʎq̈揉(DLCǉ)
// : ύXׂʎq̈
// o: ύXꂽʎq̈
//-----------------------------------------------------------------------------
U8 ComputeIdField(U8 lin_id_wo_dlc,U8 dlc) {
  U8    tmp_id;

  tmp_id= lin_id_wo_dlc & 0xCF;					// DLCޯĈʒu
  if(dlc == 2) {								// 2޲ĂŁA
	tmp_id |=   0x10;							// DLC=01
  }else if(dlc== 4) {							// 4޲ĂŁA
	tmp_id |=   0x20;							// DLC=10
  }else if(dlc== 8) {							// 8޲ĂŁA
	tmp_id |=   0x30;							// DLC=11
  }
  return tmp_id;								// DLCtʎqƋɕA
}

//-----------------------------------------------------------------------------
// : Mڰя
// : (my_schedule\̂Ŏgp)ڰт̎ʎqƗ
//-----------------------------------------------------------------------------
void DataRequest_Notification(U8 TransmitId,U8 TransmitSize){
  U8 data_cnt;
  t_schedule *   pt_schedule;

  pt_schedule = &my_schedule;					// үލ\߲
  if (TransmitId != 0x3C) {						// Lʎ呕uvڰшȊOŁA
	for (data_cnt = 0 ; data_cnt < TransmitSize; data_cnt++ )	// ް
	  tab_data[data_cnt] = pt_schedule->frame_message[Frame_index].frame_data[data_cnt];
  }else{										// Lʎ呕uvڰтŁA
	for (data_cnt = 0 ; data_cnt < TransmitSize; data_cnt++ )	// x~үޗpް
	  tab_data[data_cnt] = 0;
  }
}

//-----------------------------------------------------------------------------
// : LLINްMʒmB()ްAgޯ̧ɕʂ܂B
// : Mʎq(4ޯ), (޲Đ) (my_schedule\̂gp܂B)
// o: 1=XVL, 0=XVȂ (ްmy_schedule\̂ɕʂ܂B)
//-----------------------------------------------------------------------------
U8 DataReceived_Notification(U8 ReceivedId,U8 ReceivedSize) {
  U8 i,u;
  t_schedule * pt_schedule;
  U8 data_has_changed_flag;
  U8 CompResult;

  data_has_changed_flag = FALSE;				// ްXV׸މ
  pt_schedule = &my_schedule;					// үލ\߲
  if(ReceivedId != 0x0C) {						// x~ߎʎqȊOŁA
	for (i=0;i<pt_schedule->number_of_frame;i++) {
	  if ((pt_schedule->frame_message[i].frame_type == 1) && ((ReceivedId & 0x0F) == pt_schedule->frame_message[i].frame_id)
		  && (ReceivedSize == pt_schedule->frame_message[i].frame_size) )  {	// M,ʎqvŁAްer
		CompResult = CompDataBuffer(cmd_lin.pt_lin_msg->pt_data,pt_schedule->frame_message[i].frame_data,ReceivedSize);
		if(CompResult) {						// ްesvŁA
		  pt_schedule->frame_message[i].data_has_changed = CompResult;			// ްXV׸ސݒ
		  for (u=0;u<ReceivedSize;u++) {		// Mްޯ̧XV
			pt_schedule->frame_message[i].frame_data[u] = cmd_lin.pt_lin_msg->pt_data[u];
		  }
		} // ްXV
	  } // M,ʎqv
	} // x~ʎqȊO
  } else if (ReceivedId == 0x0C) {				// x~ߎʎqŁA
#ifdef _SLEEP_TIMOUT_DETECTION
	if (cmd_lin.pt_lin_msg->pt_data[0] == 0) {	// x~ߊm(ް擪޲=0)ŁA
	  LINSleepFlag =  1;						// LINx~׸ސݒ
	}
#endif
  }
  return data_has_changed_flag;					// ްXV׸ނƋɕA
}

//-----------------------------------------------------------------------------
// : 2LINް ޯ̧r
// : ް ޯ̧ ߲
// o: 1=sv, 0=v
//-----------------------------------------------------------------------------
U8 CompDataBuffer (U8 * Buffer1, U8 * Buffer2,U8 BufferSize) {
  U8 i;

  for (i= 0;i<BufferSize;i++){					// ް ޯ̧r
	if  (Buffer1[i] !=  Buffer2[i]) {			// Ή޲ĕsvŁA
	  return 1;									// svƋɕA
	}
  }
  return 0;										// vƋɕA
}

//-----------------------------------------------------------------------------
// : VKLINڰёMJn
// : Ȃ (my_schedule\̂frame_indexgp܂B)
// o: Ȃ (my_schedule\̂gp܂B)
//-----------------------------------------------------------------------------
void Start_Lin_Master (void){
  t_schedule *   pt_schedule;
  U8 i;

  pt_schedule = &my_schedule;					// үލ\߲
  Lin_clear_status();							// LIN׸ޏ
  if(Frame_index >=  (pt_schedule->number_of_frame-1)) {
	Frame_index = 0;
  }else {
	Frame_index ++ ;
  }

//if(Frame_index <  pt_schedule->number_of_frame) {
#ifdef _SLEEP_TIMOUT_DETECTION
	if(lin_sleep_message_request) {				// Lʎ呕uvł̋x~ߗvŁA
	  for(i=0;i<8;i++) {						// 8޲ ްS0ݒ
		tab_data[i] = 0;
	  }

	  msg_lin.id = ComputeIdField(0x0C,8);		// ʎq$3Cw
	  cmd_lin.cmd = LIN_CMD_M_TX;				// x~ڰёMw
	  cmd_lin.pt_lin_msg = &msg_lin;			// LINүޒ`߲ݒ
	  msg_lin.pt_data = &tab_data[0];			// ް ޯ̧ ߲ݒ
	  LinTxCtr = 2000;							// MJnx2000ޯĎԎw
	  lin_cmd(&cmd_lin);						// LINߎsJn
	}else if(lin_master_in_sleep_mode){			// Lʎ呕uvł̋x~ߗvȊOŁA
	  LinTxCtr = 100;							// MJnx100ޯĎԎw
#else
	if(0) {
#endif

	}else if ( pt_schedule->frame_message[Frame_index].frame_type == STANDARD_LIN_FRAME_TYPE ) {	// 呕uMڰтŁA
	  DataRequest_Notification(pt_schedule->frame_message[Frame_index].frame_id,pt_schedule->frame_message[Frame_index].frame_size);
	  msg_lin.id = ComputeIdField(pt_schedule->frame_message[Frame_index].frame_id,pt_schedule->frame_message[Frame_index].frame_size);
	  cmd_lin.cmd = LIN_CMD_M_TX;				// 呕uMڰюw
	  cmd_lin.pt_lin_msg = &msg_lin;			// LINүޒ`߲ݒ
	  msg_lin.pt_data = &tab_data[0];			// ް ޯ̧ ߲ݒ
	  LinTxCtr = pt_schedule->frame_message[Frame_index].frame_delay;	// MJnxw
	  lin_cmd(&cmd_lin);						// LINߎsJn
	} else if ( pt_schedule->frame_message[Frame_index].frame_type == REMOTE_LIN_FRAME_TYPE ) {		// 呕uMڰтŁA
	  msg_lin.id = ComputeIdField(pt_schedule->frame_message[Frame_index].frame_id,pt_schedule->frame_message[Frame_index].frame_size);
	  cmd_lin.cmd = LIN_CMD_M_RX;				// 呕uMڰюw
	  cmd_lin.pt_lin_msg = &msg_lin;			// LINүޒ`߲ݒ
	  msg_lin.pt_data = &tab_data[0];			// ް ޯ̧ ߲ݒ
	  LinTxCtr = pt_schedule->frame_message[Frame_index].frame_delay;	// MJnxw
	  lin_cmd(&cmd_lin);						// LINߎsJn
	}
//}
}

//-----------------------------------------------------------------------------
// : LINޭ׊֐(T/C1ꊄ荞݂N)
// : Ȃ (my_schedule\̂gp܂B)
//-----------------------------------------------------------------------------
U8 l_sch_tick (void) {

  if(LinTxCtr > 0) {							// MJnxv=0ȊOŁA
	LinTxCtr--;									// MJnxv팸
  }
  lin_status = lin_getstatus(&cmd_lin);			// LINԎ擾
  if (lin_status == LIN_ACTION_ONGOING){		// LIN튈isԂŁA
												// ܂B
  } else if ((LIN_ACTION_COMPLETED == lin_status) ) {	// LIN튈ԂŁA
	if (LIN_CMD_M_RX == cmd_lin.cmd) {			// 呕uMŁA
	  DataReceived_Notification((msg_lin.id & 0x0F) ,id_to_dlc (msg_lin.id));	// Mް擾
	  Lin_clear_status();						// LIN׸ޏ
	} else {
#ifdef _SLEEP_TIMOUT_DETECTION
	  if(lin_sleep_message_request) {			// Lʎ呕uvł̋x~ߑMŁA
		lin_sleep_message_request = 0;			// Lʎ呕uvł̋x~ߗv׸މ
		lin_master_in_sleep_mode = 1;			// 呕ux~׸ސݒ
		Lin_cmd_gotosleep();					// LINԋ@\Ԕԍx~ɕύX
	  }
#endif
	}
  } else if ((LIN_AVAILABLE == lin_status) && (LinTxCtr == 0) ) {	// LIN험pMJnxo߂ŁA
	Start_Lin_Master();							// VKLINڰёMJn
  } else {										// ̑(ُȂ)ŁA
#ifdef CAN_LIN_GATEWAY_ENABLE
	if(lin_status & 0x80)						// ُ픭ŁA
	  SendCanErrorFrame = 1;					// CANُڰёMv׸ސݒ
	LinErrorMessage = lin_status;				// LINُݒ
#endif
#ifdef _COUNTING_ERRORS_ENABLE
	update_error_counter(lin_status);			// Ήُvis
#endif

	if(LinTxCtr == 0) {							// MJnxo߂ŁA
	  Start_Lin_Master();						// VKLINڰёMJn
	}
  }
  return 0;
}

#ifdef _COUNTING_ERRORS_ENABLE
//-----------------------------------------------------------------------------
// : ُvXV(is)
//-----------------------------------------------------------------------------
void update_error_counter(U8 status){

  if ((status & LIN_ERROR_BIT)==LIN_ERROR_BIT){								// ޯČLŁA
	countBERR++;															// ޯĈُvis
  }else if ((status & LIN_ERROR_CSUM)==LIN_ERROR_CSUM){						// ьLŁA
	countCERR++;															// ьvis
  }else if ((status & LIN_ERROR_PARITY)==LIN_ERROR_PARITY){					// ʎqèLŁA
	countPERR++;															// ʎqèvis
  }else if ((status & LIN_ERROR_SYNCHRO)==LIN_ERROR_SYNCHRO){				// ُLŁA
	countSERR++;															// ُvis
  }else if ((status & LIN_ERROR_NO_RESPONDING)==LIN_ERROR_NO_RESPONDING){	// ]uُLŁA
	countRERR++;															// ]uُvis
  }
}
#endif
